VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsSystem"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'**************************************************
'* Date   : 03/22/2002                            *
'* Name   : Matthias Bartelt                      *
'* Changed: 08/30/2002                            *
'* Info   : System functions/subs                 *
'**************************************************

'Variables must be declared
Option Explicit


'**************************************************
'*------------------------------------------------*
'*------------------DECLARATIONS------------------*
'*------------------------------------------------*
'**************************************************

'*** API
Private Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Private Declare Function CombineRgn Lib "gdi32" (ByVal hDestRgn As Long, ByVal hSrcRgn1 As Long, ByVal hSrcRgn2 As Long, ByVal nCombineMode As Long) As Long
Private Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hDC As Long) As Long
Private Declare Function CreateDIBSection Lib "gdi32" (ByVal hDC As Long, pBitmapInfo As BITMAPINFO, ByVal un As Long, ByVal lplpVoid As Long, ByVal handle As Long, ByVal dw As Long) As Long
Private Declare Function CreateRectRgn Lib "gdi32" (ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Private Declare Function DeleteDC Lib "gdi32" (ByVal hDC As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long
Private Declare Function GetDC Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function GetDeviceCaps Lib "gdi32" (ByVal hDC As Long, ByVal nIndex As Long) As Long
Private Declare Function GetDIBits Lib "gdi32" (ByVal aHDC As Long, ByVal hBitmap As Long, ByVal nStartScan As Long, ByVal nNumScans As Long, lpBits As Any, lpBI As BITMAPINFO, ByVal wUsage As Long) As Long
Private Declare Function GetKeyState Lib "user32" (ByVal nVirtKey As Long) As Integer
Private Declare Function GetModuleHandle Lib "kernel32" Alias "GetModuleHandleA" (ByVal lpModuleName As String) As Long
Private Declare Function GetPixel Lib "gdi32" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long) As Long
Private Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Private Declare Function GetProcAddress Lib "kernel32" (ByVal hModule As Long, ByVal FunctionName As String) As Long
Private Declare Function GetVersionEx Lib "kernel32" Alias "GetVersionExA" (lpVersionInformation As OSVERSIONINFO) As Long
Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Private Declare Function GetWindowsDirectory Lib "kernel32" Alias "GetWindowsDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long
Private Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal LibraryFileName As String) As Long
Private Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Private Declare Function RegCreateKeyEx Lib "advapi32.dll" Alias "RegCreateKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal Reserved As Long, ByVal lpClass As String, ByVal dwOptions As Long, ByVal samDesired As Long, ByVal lpSecurityAttributes As Any, phkResult As Long, lpdwDisposition As Long) As Long
Private Declare Function RegDeleteKey Lib "advapi32.dll" Alias "RegDeleteKeyA" (ByVal hKey As Long, ByVal lpSubKey As String) As Long
Private Declare Function RegDeleteValue Lib "advapi32.dll" Alias "RegDeleteValueA" (ByVal hKey As Long, ByVal lpValueName As String) As Long
Private Declare Function RegFlushKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Private Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As Long, phkResult As Long) As Long
Private Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Any) As Long
Private Declare Function RegSetValueEx Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, lpData As Long, ByVal cbData As Long) As Long
Private Declare Function RegSetValueEx_Str Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, ByVal lpData As String, ByVal cbData As Long) As Long
Private Declare Function ReleaseDC Lib "user32" (ByVal hwnd As Long, ByVal hDC As Long) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hDC As Long, ByVal hObject As Long) As Long
Private Declare Function SetLayeredWindowAttributes Lib "user32" (ByVal hwnd As Long, ByVal crKey As Long, ByVal bAlpha As Byte, ByVal dwFlags As Long) As Long
Private Declare Function SetWindowLong Lib "user32.dll" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function SetWindowPos Lib "user32" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal lPosX As Long, ByVal lPosY As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long
Private Declare Function SetWindowRgn Lib "user32" (ByVal hwnd As Long, ByVal hRgn As Long, ByVal bRedraw As Boolean) As Long
Private Declare Function SHAppBarMessage Lib "shell32.dll" (ByVal dwMessage As Long, pData As APPBARDATA) As Long
Private Declare Function SHGetPathFromIDList Lib "shell32.dll" Alias "SHGetPathFromIDListA" (ByVal pidl As Long, ByVal pszPath As String) As Long
Private Declare Function SHGetSpecialFolderLocation Lib "shell32.dll" (ByVal hwndOwner As Long, ByVal nFolder As Long, pidl As ITEMIDLIST) As Long
Private Declare Function SystemParametersInfo Lib "user32" Alias "SystemParametersInfoA" (ByVal uAction As Long, ByVal uParam As Long, ByVal lpvParam As Any, ByVal fuWinIni As Long) As Long
Private Declare Function UpdateLayeredWindow Lib "user32.dll" (ByVal hwnd As Long, ByVal hdcDst As Long, pptDst As Any, psize As Any, ByVal hdcSrc As Long, pptSrc As Any, crKey As Long, ByVal pblend As Long, ByVal dwFlags As Long) As Long
Private Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Long
Private Declare Sub OleTranslateColor Lib "oleaut32.dll" (ByVal clr As Long, ByVal hpal As Long, ByRef lpcolorref As Long)


'*** Constants
Private Const ABM_GETTASKBARPOS = &H5
Private Const AC_DST_NO_ALPHA = &H20
Private Const AC_DST_NO_PREMULT_ALPHA = &H10
Private Const AC_SRC_ALPHA = &H1
Private Const AC_SRC_NO_ALPHA = &H2
Private Const AC_SRC_NO_PREMULT_ALPHA = &H1
Private Const AC_SRC_OVER = &H0
Private Const BI_RGB = 0&
Private Const DIB_RGB_COLORS = 0
Private Const ERROR_SUCCESS = 0&
Private Const GWL_EXSTYLE = (-20)
Private Const GWL_STYLE = (-16)
Private Const HWND_NOTOPMOST = -2
Private Const HWND_TOPMOST = -1
Private Const KEY_ENUMERATE_SUB_KEYS = &H8
Private Const KEY_NOTIFY = &H10
Private Const KEY_QUERY_VALUE = &H1
Private Const KEY_READ = KEY_QUERY_VALUE Or KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY
Private Const KEY_sCreate_LINK = &H20
Private Const KEY_sCreate_SUB_KEY = &H4
Private Const KEY_SET_VALUE = &H2
Private Const KEY_ALL_ACCESS = KEY_QUERY_VALUE Or KEY_SET_VALUE Or KEY_sCreate_SUB_KEY Or KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY Or KEY_sCreate_LINK
Private Const LWA_ALPHA = &H2
Private Const LWA_COLORKEY = &H1
Private Const REG_BINARY = 3
Private Const REG_DWORD = 4
Private Const REG_DWORD_BIG_ENDIAN = 5
Private Const REG_DWORD_LITTLE_ENDIAN = 4
Private Const REG_EXPAND_SZ = 2
Private Const REG_LINK = 6
Private Const REG_MULTI_SZ = 7
Private Const REG_NONE = 0
Private Const REG_OPTION_NON_VOLATILE = &H0
Private Const REG_SZ = 1
Private Const RGN_OR = 2
Private Const SPI_SETDESKWALLPAPER = 20
Private Const SPIF_UPDATEINIFILE = &H1
Private Const SWP_NOMOVE = &H2
Private Const SWP_NOSIZE = &H1
Private Const ULW_ALPHA = &H2
Private Const ULW_COLORKEY = &H1
Private Const ULW_OPAQUE = &H4
Private Const VER_PLATFORM_WIN32_NT = 2
Private Const VER_PLATFORM_WIN32_WINDOWS = 1
Private Const VER_PLATFORM_WIN32s = 0
Private Const WS_EX_LAYERED = &H80000


'*** Enumss
Public Enum COLORDEPTH
    enmColorsUnknown = 0
    enmColors_1 = 1
    enmColors_16 = 2
    enmColors_256 = 3
    enmColors_16Mio = 4
    enmColors_24Mio = 5
    enmColors_32Mio = 6
End Enum
'---
Public Enum KEYSPRESSED
    VK_CONTROL = &H11
    VK_LCONTROL = &HA2
    VK_LMenu = &HA4
    VK_LSHIFT = &HA0
    VK_MENU = &H12
    VK_RCONTROL = &HA3
    VK_RMENU = &HA5
    VK_RSHIFT = &HA1
    VK_SHIFT = &H10
End Enum

'---
Public Enum REGROOTS
    HKEY_CLASSES_ROOT = &H80000000
    HKEY_CURRENT_USER = &H80000001
    HKEY_LOCAL_MACHINE = &H80000002
    HKEY_USERS = &H80000003
    HKEY_PERFORMANCE_DATA = &H80000004
    HKEY_CURRENT_CONFIG = &H80000005
    HKEY_DYN_DATA = &H80000006
End Enum
'---
Public Enum OPERATINGSYSTEM
    enmOSUnknown = 0
    enmOSWin32s = 1
    enmOSWin95 = 2
    enmOSWinNT3 = 3
    enmOSWinNT4 = 4
    enmOSWin98 = 5
    enmOSWin98SE = 6
    enmOSWinME = 7
    enmOSWin2000 = 8
    enmOSWinXP = 9
End Enum
'---
Public Enum SPECIALFOLDERS
    WINDOWS = &H24
    TEMPLATES = &H15
    System = &H25
    STARTUP = &H7
    STARTMENU = &HB
    SENDTO = &H9
    RECENT = &H8
    PROGRAMS = &H2
    PROFILE = &H28
    Printers = &H4
    PERSONAL = &H5
    NETWORK = &H12
    MYPICTURES = &H27
    INTERNET = &H1
    Fonts = &H14
    FAVORITES = &H6
    DRIVES = &H11
    DESKTOP = &H0
    Controls = &H3
    CONNECTIONS = &H31
End Enum
'---
Public Enum SPLITMODE
    m_Filename = 0
    m_Extension = 1
    m_Both = 2
End Enum
'---
Public Enum TASKBAR
    enmBottom
    enmLeft
    enmRight
    enmtop
End Enum

'*** Types
Private Type BITMAPINFOHEADER
    biSize          As Long
    biWidth         As Long
    biHeight        As Long
    biPlanes        As Integer
    biBitCount      As Integer
    biCompression   As Long
    biSizeImage     As Long
    biXPelsPerMeter As Long
    biYPelsPerMeter As Long
    biClrUsed       As Long
    biClrImportant  As Long
End Type
'---
Private Type RGBQUAD
    rgbBlue         As Byte
    rgbGreen        As Byte
    rgbRed          As Byte
    rgbReserved     As Byte
End Type
'---
Private Type BITMAPINFO
    bmiHeader       As BITMAPINFOHEADER
    bmiColors       As RGBQUAD
End Type
'---
Private Type BLENDFUNCTION
    BlendOp As Byte
    BlendFlags As Byte
    SourceConstantAlpha As Byte
    AlphaFormat As Byte
End Type
'---
Private Type OSVERSIONINFO
    dwOSVersionInfoSize As Long
    dwMajorVersion As Long
    dwMinorVersion As Long
    dwBuildNumber As Long
    dwPlatformId As Long
    szCSDVersion As String * 128
End Type
'---
Private Type POINTAPI
    lPosX As Long
    lPosY As Long
End Type
'---
Private Type RECT
    Left             As Long
    Top              As Long
    Right            As Long
    Bottom           As Long
End Type
'---
Private Type APPBARDATA
    cbSize           As Long
    hwnd             As Long
    uCallbackMessage As Long
    uEdge            As Long
    rc               As RECT
    lParam           As Long
End Type
'---
Private Type Size
    cx As Long
    cy As Long
End Type
'---
Private Type SHITEMID
    cb As Long
    abID As Byte
End Type
'---
Private Type ITEMIDLIST
    mkid As SHITEMID
End Type

'*** Variables
Dim lWindowLong As Long
Dim m_ColorDepth      As COLORDEPTH
Dim m_OperatingSystem As OPERATINGSYSTEM



'**************************************************
'*------------------------------------------------*
'*-----------------FUNCTIONS/SUBS-----------------*
'*------------------------------------------------*
'**************************************************

Private Sub Class_Initialize()
'**************************************************
'* Parameter   : NONE                             *
'* Return value: NONE                             *
'* Changed     : 03/22/2002                       *
'* Info        : When the class is initializing.  *
'**************************************************

    'What system
    Call sGetOperatingSystem
    
    'What color depth
    Call sGetColorDepth
    
End Sub

Private Sub sGetColorDepth()
'**************************************************
'* Parameter   : NONE                             *
'* Return value: NONE                             *
'* Changed     : 03/22/2002                       *
'* Info        : Returns the color depth.         *
'**************************************************

    'Variables
    Dim lHDC        As Long
    Dim lPixelCount As Long
    Dim lResult     As Long

    'Get the main DC
    lHDC = GetDC(0)
    lPixelCount = GetDeviceCaps(lHDC, 14) * GetDeviceCaps(lHDC, 12)
    
    lResult = ReleaseDC(0, lHDC)
    
    'Get the depth
    Select Case lPixelCount
        Case 1: m_ColorDepth = enmColors_1
        Case 4: m_ColorDepth = enmColors_16
        Case 8: m_ColorDepth = enmColors_256
        Case 16: m_ColorDepth = enmColors_16Mio
        Case 24: m_ColorDepth = enmColors_24Mio
        Case 32: m_ColorDepth = enmColors_32Mio
        Case Else: m_ColorDepth = enmColorsUnknown
    End Select

End Sub

Private Sub sGetOperatingSystem()
'**************************************************
'* Parameter   : NONE                             *
'* Return value: NONE                             *
'* Changed     : 03/22/2002                       *
'* Info        : Returns the operationg system.   *
'**************************************************

    'Variables
    Dim lBuildNr     As Long
    Dim typOSVersion As OSVERSIONINFO
    
    'Reads the OS infos
    typOSVersion.dwOSVersionInfoSize = Len(typOSVersion)
    Call GetVersionEx(typOSVersion)
    
    'Set the default value
    m_OperatingSystem = enmOSUnknown
    
    'Read the actual version from the infos
    With typOSVersion
        'Set the right build number
        If (.dwBuildNumber And &HFFFF&) > &H7FFF Then
            lBuildNr = (.dwBuildNumber And &HFFFF&) - &H10000
        Else
            lBuildNr = .dwBuildNumber And &HFFFF&
        End If
        
        'Is it on a NT or normal platform
        If .dwPlatformId = VER_PLATFORM_WIN32_NT Then
            If .dwMajorVersion = 3 Then
                m_OperatingSystem = enmOSWinNT3
            ElseIf .dwMajorVersion = 4 Then
                m_OperatingSystem = enmOSWinNT4
            ElseIf .dwMajorVersion = 5 Then
                If .dwMinorVersion = 0 Then
                    m_OperatingSystem = enmOSWin2000
                ElseIf .dwMinorVersion = 1 Then
                    m_OperatingSystem = enmOSWinXP
                End If
            End If
        ElseIf .dwPlatformId = VER_PLATFORM_WIN32_WINDOWS Then
            If (.dwMajorVersion > 4) Or (.dwMajorVersion = 4 And _
                .dwMinorVersion = 10) Then
                If lBuildNr = 1998 Then
                    m_OperatingSystem = enmOSWin98
                Else
                    m_OperatingSystem = enmOSWin98SE
                End If
            ElseIf (.dwMajorVersion = 4 And .dwMinorVersion = 0) Then
                m_OperatingSystem = enmOSWin95
            ElseIf (.dwMajorVersion = 4 And .dwMinorVersion = 90) Then
                m_OperatingSystem = enmOSWinME
            End If
        ElseIf .dwPlatformId = VER_PLATFORM_WIN32s Then
            m_OperatingSystem = enmOSWin32s
        End If
    End With
    
End Sub

Public Function fRegKeyExist( _
    lRoot As REGROOTS, _
    sKey As String _
    ) As Boolean
'**************************************************
'* Parameter   : lRoot: The regedit root          *
'*               sKey : Key to check              *
'* Return value: If the operation was successful  *
'* Changed     : 03/22/2002                       *
'* Info        : Check if a key in the registry   *
'*               exist.
'**************************************************

    'Variables
    Dim hKey    As Long
    Dim lResult As Long
    
    'Check if the key exist
    lResult = RegOpenKeyEx(lRoot, sKey, 0, KEY_READ, hKey)
    If lResult = ERROR_SUCCESS Then Call RegCloseKey(hKey)
    
    'Returns the value
    fRegKeyExist = (lResult = 0)
    
End Function

Public Function fRegKeyCreate( _
    lRoot As REGROOTS, _
    sNewKey As String _
    ) As Boolean
'**************************************************
'* Parameter   : lRoot   : The regedit root       *
'*               sNewKey : The new key name       *
'* Return value: If the operation was successful  *
'* Changed     : 03/22/2002                       *
'* Info        : sCreate a new key in the registry.*
'**************************************************

    'Variables
    Dim hKey       As Long
    Dim lRegResult As Long
    Dim lResult    As Long
    
    'Creates the new key
    lResult = RegCreateKeyEx(lRoot, sNewKey, 0, vbNullString, _
        REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, 0&, hKey, lRegResult)
        
    'Returns if the operation was successful
    If lResult = ERROR_SUCCESS Then
        lResult = RegFlushKey(hKey)
            If lResult = ERROR_SUCCESS Then Call RegCloseKey(hKey)
            fRegKeyCreate = (lRegResult <> 0)
    End If

End Function

Public Function fRegKeyDelete( _
    lRoot As REGROOTS, _
    sKey As String _
    ) As Boolean
'**************************************************
'* Parameter   : lRoot : The regedit root         *
'*               sKey  : Key to delete            *
'* Return value: If the operation was successful  *
'* Changed     : 03/22/2002                       *
'* Info        : Delete a key.                    *
'**************************************************

    'Delete the key and return if the operation was successful
    fRegKeyDelete = (RegDeleteKey(lRoot, sKey) = 0)
    
End Function

Public Function fRegValueDelete( _
    lRoot As REGROOTS, _
    sKey As String, _
    sField As String _
    ) As Boolean
'**************************************************
'* Parameter   : lRoot : The regedit root         *
'*               sKey  : Key to the value         *
'*               sField: Value to delete          *
'* Return value: If the operation was successful  *
'* Changed     : 03/22/2002                       *
'* Info        : Delete a value.                  *
'**************************************************

    'Variables
    Dim hKey    As Long
    Dim lResult As Long

    'Delete the values
    lResult = RegOpenKeyEx(lRoot, sKey, 0, KEY_ALL_ACCESS, hKey)
    If lResult = ERROR_SUCCESS Then
        lResult = RegDeleteValue(hKey, sField)
        lResult = RegCloseKey(hKey)
    End If
    
    'Returns if the operation was successful
    fRegValueDelete = (lResult = 0)
    
End Function

Public Function fRegValueSet( _
    lRoot As REGROOTS, _
    sKey As String, _
    sField As String, _
    vValue As Variant _
    ) As Boolean
'**************************************************
'* Parameter   : lRoot : The regedit root         *
'*               sKey  : Key to the value         *
'*               sField: Value to set             *
'*               vValue: The new value            *
'* Return value: If the operation was successful  *
'* Changed     : 03/22/2002                       *
'* Info        : Set a new value into the         *
'*               registry.                        *
'**************************************************

    'Variables
    Dim hKey    As Long
    Dim lResult As Long
    Dim lValue  As Long
    Dim sValue  As String
  
    'Wert in ein Feld der Registry schreiben
    lResult = RegOpenKeyEx(lRoot, sKey, 0, KEY_ALL_ACCESS, hKey)
    If lResult = ERROR_SUCCESS Then
      Select Case VarType(vValue)
        Case vbInteger, vbLong
            lValue = CLng(vValue)
            lResult = RegSetValueEx(hKey, sField, 0, REG_DWORD, _
                lValue, 4)
        Case vbString
            sValue = CStr(vValue)
            lResult = RegSetValueEx_Str(hKey, sField, 0, REG_SZ, sValue, _
            Len(sValue) + 1)
      End Select
      lResult = RegCloseKey(hKey)
    End If
    
    fRegValueSet = (lResult = 0)
    
End Function

Public Function fRegValueGet( _
    lRoot As REGROOTS, _
    sKey As String, _
    sField As String, _
    vValue As Variant _
    ) As Boolean
'**************************************************
'* Parameter   : lRoot : The regedit root         *
'*               sKey  : Key to the value         *
'*               sField: Value to get             *
'*               vValue: The value                *
'* Return value: If the operation was successful  *
'* Changed     : 03/22/2002                       *
'* Info        : Get a value from a field in the  *
'*               registry.                        *
'**************************************************

    'Variables
    Dim hKey    As Long
    Dim lBuffer As Long
    Dim lResult As Long
    Dim lType   As Long
    Dim sBuffer As String

    'Read the value from the registry
    lResult = RegOpenKeyEx(lRoot, sKey, 0, KEY_READ, hKey)
    If lResult = ERROR_SUCCESS Then
      lResult = RegQueryValueEx(hKey, sField, 0&, lType, ByVal _
        0&, lBuffer)
      If lResult = ERROR_SUCCESS Then
        Select Case lType
          Case REG_SZ
            sBuffer = Space(lBuffer + 1)
            lResult = RegQueryValueEx(hKey, sField, 0&, lType, _
                ByVal sBuffer, lBuffer)
            If lResult = ERROR_SUCCESS Then vValue = sBuffer
          Case REG_DWORD
            lResult = RegQueryValueEx(hKey, sField, 0&, lType, _
                lBuffer, lBuffer)
            If lResult = ERROR_SUCCESS Then vValue = lBuffer
        End Select
      End If
    End If
    
    If lResult = ERROR_SUCCESS Then lResult = RegCloseKey(hKey)
    fRegValueGet = (lResult = 0)
    
End Function

Public Function fINIRead( _
    ByVal sPath As String, _
    ByVal sSection As String, _
    ByVal sKey As String _
    ) As String
'**************************************************
'* Parameter   : sPath   : Path to the INI file   *
'*               sSection: Section to read        *
'*               sKey    : Key to read            *
'* Return value: The value from the INI           *
'* Changed     : 05/20/2002                       *
'* Info        : Read a INI file value.           *
'**************************************************

On Error GoTo errError

    'Variables
    Dim lResult As Long
    Dim sResult As String * 255

    'Read the value
    lResult = GetPrivateProfileString(sSection, sKey, "", sResult, 255, sPath)
    
    'Return the value
    If lResult <> 0 Then fINIRead = Left(sResult, lResult)

    Exit Function
    
errError:
    fINIRead = ""

End Function

Public Sub sINIWrite( _
    ByVal sPath As String, _
    ByVal sSection As String, _
    ByVal sKey As String, _
    ByVal sValue As String _
    )
'**************************************************
'* Parameter   : sPath   : Path to the INI file   *
'*               sSection: Section to read        *
'*               sKey    : Key to read            *
'*               svalue  : Value to write into
'* Return value: NON                              *
'* Changed     : 05/20/2002                       *
'* Info        : Write a INI file value.          *
'**************************************************

On Error Resume Next

    'Variables
    Dim lResult As Long
    
    'Write the value
    lResult = WritePrivateProfileString(sSection, sKey, sValue, sPath)
    
End Sub

Public Sub sSetFormOnTop( _
    lhWnd As Long, _
    Optional bOnTop As Boolean = True _
    )
'**************************************************
'* Parameter   : lhWnd : The window hWnd          *
'*               bOnTop: TRUE = on top            *
'* Return value: NONE                             *
'* Changed     : 03/22/2002                       *
'* Info        : Set a form always on top.        *
'**************************************************

    'Set the form on top or not
    SetWindowPos lhWnd, IIf((bOnTop), HWND_TOPMOST, HWND_NOTOPMOST), _
        0, 0, 0, 0, SWP_NOMOVE + SWP_NOSIZE

End Sub

Public Sub sMakeFormTransparent( _
    lhWnd As Long, _
    bytRate As Byte _
    )
'**************************************************
'* Parameter   : lhWnd  : The window hWnd         *
'* Return value: bytRate: 0-255; Transparence     *
'* Changed     : 07/05/2002                       *
'* Info        : Makes a form transparent.        *
'**************************************************

    'Check the system
    If (gGetOS <> enmOSWin2000) And (gGetOS <> enmOSWinXP) Then Exit Sub

    lWindowLong = GetWindowLong(lhWnd, GWL_EXSTYLE)
    
    'Make the form transparent
    If bytRate < 255 Then 'Set the transparence
        lWindowLong = lWindowLong Or WS_EX_LAYERED
        SetWindowLong lhWnd, GWL_EXSTYLE, lWindowLong
        SetLayeredWindowAttributes lhWnd, 0, bytRate, LWA_ALPHA
    Else                  'Reset the form
        lWindowLong = lWindowLong Xor WS_EX_LAYERED
        SetWindowLong lhWnd, GWL_EXSTYLE, lWindowLong
    End If
    
End Sub
    
Public Function fGetWinDir() As String
'**************************************************
'* Parameter   : NONE                             *
'* Return value: The windows directory path       *
'* Changed     : 03/25/2002                       *
'* Info        : Get the windows directory path.  *
'**************************************************

    'Variables
    Dim sBuffer As String
    
    'sCreate a buffer
    sBuffer = String(255, Chr(0))
    
    'Get the path
    fGetWinDir = Left(sBuffer, GetWindowsDirectory(sBuffer, Len(sBuffer)))
    
End Function

Public Sub sSetWallpaper( _
    ByVal sFilePath As String _
    )
'**************************************************
'* Parameter   : sFilePath: Path to the image     *
'* Return value: NONE                             *
'* Changed     : 03/25/2002                       *
'* Info        : Set a new desktop background.    *
'**************************************************

    'Set the new background
    SystemParametersInfo SPI_SETDESKWALLPAPER, 0, sFilePath, SPIF_UPDATEINIFILE

End Sub

Public Function fGetSpecialFolder( _
    enmFOLDER As SPECIALFOLDERS _
    ) As String
'**************************************************
'* Parameter   : enmFOLDER: Folder to get         *
'* Return value: NONE                             *
'* Changed     : 05/23/2002                       *
'* Info        : Get the path of a special folder.*
'**************************************************

    'Variables
    Dim lResult As Long
    Dim sPath   As String
    Dim typITEM As ITEMIDLIST
    
    'Get the special folder
    lResult = SHGetSpecialFolderLocation(100, enmFOLDER, typITEM)
    
    'If no error occured
    If lResult = 0 Then
        sPath = Space(512)
        lResult = SHGetPathFromIDList(ByVal typITEM.mkid.cb, ByVal sPath)
        fGetSpecialFolder = Left(sPath, InStr(sPath, Chr(0)) - 1)
        Exit Function
    End If
    
    fGetSpecialFolder = ""
    
End Function

Public Function fGetPathLast( _
    sFilePath As String _
    ) As String
'**************************************************
'* Parameter   : sFilePath: Source path           *
'* Return value: The new path                     *
'* Changed     : 05/24/2002                       *
'* Info        : Go one path up from the source.  *
'**************************************************
    
    'Variables
    Dim nCount As Long
    
    'If it is a path
    If InStr(1, sFilePath, "\") Then
        For nCount = Len(sFilePath) To 0 Step -1
            If Mid(sFilePath, nCount, 1) = "\" Then
                fGetPathLast = Left(sFilePath, nCount - 1)
                Exit For
            End If
        Next
    Else
        'Return the path
        fGetPathLast = sFilePath
    End If
    
End Function

Public Function fGetFilenameFromPath( _
    sFilePath As String, _
    enmSplitMode As SPLITMODE _
    ) As String
'**************************************************
'* Parameter   : sFilePath   : String to check    *
'*               enmSplitMode: With extend.       *
'* Return value: The filename from a path         *
'* Changed     : 03/23/2002                       *
'* Info        : Get the filename from a path.    *
'**************************************************

On Error GoTo errError

    'Variables
    Dim nCount As Long
    Dim sFile  As String
    
    'If it is a whole path string
    If InStr(1, sFilePath, "\", vbTextCompare) <> 0 Then
        For nCount = Len(sFilePath) To 0 Step -1
            If Mid(sFilePath, nCount, 1) = "\" Then
                sFile = Right(sFilePath, Len(sFilePath) - nCount)
                Exit For
            End If
        Next
    Else 'or only a filename
        sFile = sFilePath
    End If
    
    'Should the Extension split away or not
    If (enmSplitMode = m_Both) Then
        fGetFilenameFromPath = sFile
        Exit Function
    ElseIf (enmSplitMode = m_Extension) Then
        'Check if a '.' exist
        If InStr(1, sFile, ".") <> 0 Then
            For nCount = Len(sFile) To 0 Step -1
                If Mid(sFile, nCount, 1) = "." Then
                    fGetFilenameFromPath = Right(sFile, Len(sFile) - nCount)
                    Exit For
                End If
            Next
        Else 'No '.' exist
            fGetFilenameFromPath = sFile
        End If
    ElseIf (enmSplitMode = m_Filename) Then
        'Do untiil the last '.'
        For nCount = Len(sFile) To 0 Step -1
            If Mid(sFile, nCount, 1) = "." Then
                fGetFilenameFromPath = Left(sFile, nCount - 1)
                Exit For
            End If
        Next
    End If
    
    Exit Function
        
errError:
    fGetFilenameFromPath = ""
    Exit Function

End Function

Public Function fExistFile( _
    sFilePath As String _
    ) As Boolean
'**************************************************
'* Parameter   : fFilePath: Path to the file      *
'* Return value: If the file exist (T/F)          *
'* Changed     : 03/23/2002                       *
'* Info        : Close the whole application.     *
'**************************************************

On Error GoTo errError

    'Check if it exist
    fExistFile = (Dir(sFilePath) <> "")

    Exit Function
        
errError:
    fExistFile = False
    Exit Function

End Function

Public Function fFunctionInDLLExist( _
    ByVal sDLLName As String, _
    ByVal sFunction As String _
    ) As Boolean
'**************************************************
'* Parameter   : sDLLName : Name of the DLL       *
'*               sFunction: Name of the function  *
'* Return value: Function exist                   *
'* Changed     : 08/03/2002                       *
'* Info        : Check if a function in a DLL     *
'*               exist.                           *
'**************************************************

    'Variables
    Dim hModule As Long
    Dim lProcAddress As Long
    
    'Try to load the dll
    hModule = LoadLibrary(sDLLName)
    
    'Found the DLL-Library
    If hModule <> 0 Then
        'Check if the function is available in the DLL
        lProcAddress = GetProcAddress(hModule, sFunction)
        FreeLibrary hModule
        'Returns the value
        fFunctionInDLLExist = CBool(lProcAddress)
    End If
  
End Function

Public Function fIsKeyPressedSpecial( _
    enmKeys As KEYSPRESSED _
    ) As Boolean
'**************************************************
'* Parameter   : enmKeys: Keys to check           *
'* Return value: Is the key pressed               *
'* Changed     : 08/03/2002                       *
'* Info        : Check if a key is pressed.       *
'**************************************************
    
    'Return the value
    fIsKeyPressedSpecial = CBool((GetKeyState(enmKeys) And &HF0000000))
    
End Function

Public Function fGetTaskbarPos( _
    ByVal enmTaskBar As TASKBAR _
    ) As Integer
'**************************************************
'* Parameter   : enmTaskBar: What way             *
'* Return value: The position                     *
'* Changed     : 08/21/2002                       *
'* Info        : Get the taskbars position.       *
'**************************************************
    
    'Variables
    Dim lResult   As Long
    Dim typAppBar As APPBARDATA

    'Get the positions
    lResult = SHAppBarMessage(ABM_GETTASKBARPOS, typAppBar)
    
    'Return the values
    With typAppBar.rc
        Select Case enmTaskBar
            Case enmBottom
                fGetTaskbarPos = .Bottom
            Case enmLeft
                fGetTaskbarPos = .Left
            Case enmRight
                fGetTaskbarPos = .Right
            Case enmtop
                fGetTaskbarPos = .Top
        End Select
    End With

End Function

Public Sub sSetFormRegion( _
    ByVal objForm As Form, _
    ByVal lTransparentColor As Long _
    )
'**************************************************
'* Parameter   : objSource        : Pic. object   *
'*               lTransparentColor: Trans. color  *
'* Return value: The regions handle               *
'* Changed     : 08/21/2002                       *
'* Info        : Set the region of a form.        *
'**************************************************
    
    'Variables
    Dim hRegion   As Long
    Dim lWinStyle As Long
    
    'Convert the system color to the normal RGB color
    If lTransparentColor < 0 Then OleTranslateColor lTransparentColor, 0&, lTransparentColor

    'Set the region
    If fFunctionInDLLExist("user32", "SetLayeredWindowAttributes") Then
        'Set the window style to layered
        lWinStyle = GetWindowLong(objForm.hwnd, GWL_EXSTYLE)
        lWinStyle = lWinStyle Or WS_EX_LAYERED
        SetWindowLong objForm.hwnd, GWL_EXSTYLE, lWinStyle
        SetLayeredWindowAttributes objForm.hwnd, lTransparentColor, 0&, LWA_COLORKEY
    End If
    
End Sub




'**************************************************
'*------------------------------------------------*
'*--------------------GET/LET---------------------*
'*------------------------------------------------*
'**************************************************

Public Property Get gGetColorDepth() As COLORDEPTH
'**************************************************
'* Changed     : 03/22/2002                       *
'* Special     : NONE                             *
'**************************************************

    'Returns the enum value
    gGetColorDepth = m_ColorDepth
    
End Property

Public Property Get gGetOS() As OPERATINGSYSTEM
'**************************************************
'* Changed     : 03/22/2002                       *
'* Special     : NONE                             *
'**************************************************

    'Returns the enum value
    gGetOS = m_OperatingSystem

End Property

Public Property Get gGetWinDir() As String
'**************************************************
'* Changed     : 03/25/2002                       *
'* Special     : NONE                             *
'**************************************************

    'Returns the win dir
    gGetWinDir = fGetWinDir

End Property


